config/routes.rb
Rails.application.routes.draw do
  scope "(:locale)", locale: /#{I18n.available_locales.join("|")}/ do
    root "articles#index"

    get 'search',to: "articles#search"

    resources :articles do
      resources :comments
    end
    resources :tags, only: [:show]
  end
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/article.rb
class Article < ApplicationRecord
	include Visible
  
	has_many :comments, dependent: :destroy
	has_rich_text :body
	has_many :taggings, dependent: :destroy
	has_many :tags, through: :taggings, dependent: :destroy

	mount_uploader :image, ImageUploader
	validates :title, presence: true
	validates :body, presence: true, length: { minimum: 5 }

	def all_tags
		self.tags.map(&:name).join(', ')
	end
	def all_tags=(names)
		self.tags = names.split(',').map do | name |
			Tag.where(name: name.strip).first_or_create!	
		end 
	end

  end

app/models/comment.rb
class Comment < ApplicationRecord
  include Visible
  belongs_to :article
end

app/models/concerns/visible.rb
module Visible
	extend ActiveSupport::Concern
  
	VALID_STATUSES = ['public', 'private', 'archived']
  
	included do
	  validates :status, inclusion: { in: VALID_STATUSES }
	end
  
	class_methods do
	  def public_count
		where(status: 'public').count
	  end
	end
  
	def archived?
	  status == 'archived'
	end
  end

app/models/tag.rb
class Tag < ApplicationRecord

	has_many :taggings
	has_many :articles, through: :taggings


end

app/models/tagging.rb
class Tagging < ApplicationRecord
  belongs_to :article
  belongs_to :tag
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base

	before_action :set_locale
	private
	
	def set_locale
		I18n.locale = params[:locale] || I18n.default_locale
	end

	def default_url_options(options = {})
		{locale: I18n.locale }.merge options
	end
end

app/controllers/articles_controller.rb
class ArticlesController < ApplicationController

  http_basic_authenticate_with name: "newlogin", password: "password", except: [:index, :show]

  def index
    @articles = Article.paginate(page: params[:page], per_page: 5)
  end
  def show
    @article = Article.find(params[:id])
  end
  def new
    @article = Article.new
  end

  def create
    @article = Article.new(article_params)

    if @article.save
      redirect_to @article
    else
      render :new
    end
  end

  def edit
    @article = Article.find(params[:id])
  end

  def update
    @article = Article.find(params[:id])

    if @article.update(article_params)
      redirect_to @article
    else
      render :edit
    end
  end

  def destroy
    @article = Article.find(params[:id])
    @article.destroy

    redirect_to root_path
  end

  def search
    @articles = Article.where("title LIKE ?","%" + params[:q]+"%")
  end

  private
    def article_params
      params.require(:article).permit(:title, :body, :status, :image, :all_tags)
    end
end

app/controllers/comments_controller.rb
class CommentsController < ApplicationController

	http_basic_authenticate_with name: "dhh", password: "secret", only: :destroy

	def create
	  @article = Article.find(params[:article_id])
	  @comment = @article.comments.create(comment_params)
	  redirect_to article_path(@article)
	end
  
	def destroy
		@article = Article.find(params[:article_id])
		@comment = @article.comments.find(params[:id])
		@comment.destroy
		redirect_to article_path(@article)
	  end
	
    private
    def comment_params
      params.require(:comment).permit(:commenter, :body, :status)
    end

  end
  

app/controllers/tags_controller.rb
class TagsController < ApplicationController
	def show
		@tag = Tag.find_by(name: params[:id])
		@articles = @tag.articles
	end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/articles_helper.rb
module ArticlesHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/views/active_storage/blobs/_blob.html.erb
<figure class="attachment attachment--<%= blob.representable? ? "preview" : "file" %> attachment--<%= blob.filename.extension %>">
  <% if blob.representable? %>
    <%= image_tag blob.representation(resize_to_limit: local_assigns[:in_gallery] ? [ 800, 600 ] : [ 1024, 768 ]) %>
  <% end %>

  <figcaption class="attachment__caption">
    <% if caption = blob.try(:caption) %>
      <%= caption %>
    <% else %>
      <span class="attachment__name"><%= blob.filename %></span>
      <span class="attachment__size"><%= number_to_human_size blob.byte_size %></span>
    <% end %>
  </figcaption>
</figure>

app/views/articles/_article.html.erb
<article class="post">
	<section class="post-head">
		<h2> <%= link_to article.title, article %> </h2>
		<small><time><%= article.created_at.to_date.strftime("%d, %B, %Y") %></time></small>
	</section>	
	<section class = "post-body clearfix">
		<%= image_tag article.image.url(:thumb), class: 'img-thumbnail thumb' if article.image?%>
	</section>
	<section class = "footer-summary">
		<%= raw article.tags.map(&:name).map{ |t| link_to t, tag_path(t), class: 'btn btn-primary btn-sm' }.join(' ') %>
	</section>
</article>

app/views/articles/_disqus.html.erb
<div id="disqus_thread"></div>
<script>
    /**
    *  RECOMMENDED CONFIGURATION VARIABLES: EDIT AND UNCOMMENT THE SECTION BELOW TO INSERT DYNAMIC VALUES FROM YOUR PLATFORM OR CMS.
    *  LEARN WHY DEFINING THESE VARIABLES IS IMPORTANT: https://disqus.com/admin/universalcode/#configuration-variables    */
    
    var disqus_config = function () {
    this.page.url = 'http://localhost.com<%= request.original_fullpath%>';  // Replace PAGE_URL with your page's canonical URL variable
    this.page.identifier = '<%= @article.id%>'; // Replace PAGE_IDENTIFIER with your page's unique identifier variable
    };
    
    (function() { // DON'T EDIT BELOW THIS LINE
    var d = document, s = d.createElement('script');
    s.src = 'https://myblog-zckvxw3r4j.disqus.com/embed.js';
    s.setAttribute('data-timestamp', +new Date());
    (d.head || d.body).appendChild(s);
    })();
</script>
<noscript>Please enable JavaScript to view the <a href="https://disqus.com/?ref_noscript">comments powered by Disqus.</a></noscript>

app/views/articles/_form.html.erb
<%= form_with model: article, html: {multipart: true} do |form| %>
	<div class="form-group">
	  <%= form.label :title %><br>
	  <%= form.text_field :title, class: 'form-control' %>
	  <% article.errors.full_messages_for(:title).each do |message|%>
		<div class="alert alert-danger"><%= message %></div>
	  <% end %>
	</div>
  
	<div class="form-group">
	  <%= form.label :body %><br>
	  <%= form.rich_text_area :body, class: 'editor' %><br>
	  <% article.errors.full_messages_for(:body).each do |message| %>
		<div class="alert alert-danger"><%= message %></div>
	  <% end %>
	</div>

	<div class="form-group">
	  <%= form.label :all_tags %><br>
	  <%= form.text_field :all_tags, class: 'form_control' %><br>
	</div>

	<div class="form-group">
	  <%= form.file_field :image%><br>
	</div>

	<div class="">
		<%= form.label :status %><br>
		<%= form.select :status, ['public', 'private', 'archived'], selected: 'public' %>
	</div>
	<div class="save_button">
	  <%= form.submit t('article.save'), class: 'btn btn-success' %>
	  <%= link_to t('article.back'), :back, class: 'btn btn-outline-secondary' %>
	</div>
  <% end %>

app/views/articles/edit.html.erb
<h1>Edit Article</h1>

<%= render "form", article: @article %>	

app/views/articles/index.html.erb
<h1><%=t('bar.articles')%></h1>

<%= t('main.numOfArticles') %> : <%= Article.public_count %>

<%= render @articles %>

<%= will_paginate @articles, renderer: 'BootstrapPaginationHelper::LinkRenderer' %>

app/views/articles/new.html.erb
<h1><%=t('article.new.title')%></h1>

<%= render "form", article: @article %>

app/views/articles/search.erb
<h1>Search Result</h1>

<%= render @articles %>

app/views/articles/show.html.erb
<article class="post">
  <h1><%= @article.title %></h1>

  <div class="body">
  <%= image_tag @article.image.url(:large), class: 'img-show' if @article.image?%>
  <%= @article.body %>
  
  </div>


  <div class="container-fluid ">
    <section class="article_change pull-xs-right">
      <%= link_to t('article.change'), edit_article_path(@article), class: 'btn btn-outline-secondary' %> | 
      <%= link_to t('article.destroy'), article_path(@article), method: :delete, data: { confirm: "Are you sure?" },  class: 'btn btn-outline-secondary'%> |
      <%= link_to t('article.back'), articles_path, class: 'btn btn-outline-secondary' %>
    </section>
  </div>
</article>

<h2><%=t('article.comment.head')%></h2>
<%= render @article.comments %>

<h2><%=t('article.comment.addComment')%></h2>
<%= render 'disqus' %>

app/views/comments/_comment.html.erb
<p>
  <strong><%=t('article.comment.commenter')%>:</strong>
  <%= comment.commenter %>
</p>

<p>
  <strong><%=t('article.comment.commentBody')%>:</strong>
  <%= comment.body %>
</p>

<p>
  <%= link_to t('article.destroy'), [comment.article, comment],
              method: :delete,
              data: { confirm: "Are you sure?" } %>
</p>

app/views/comments/_form.html.erb
<%= form_with model: [ @article, @article.comments.build ] do |form| %>
	<p>
	  <%= form.label t('article.comment.commenter') %><br>
	  <%= form.text_field t('article.comment.commenter') %>
	</p>
	<p>
	  <%= form.label t('article.comment.commentBody') %><br>
	  <%= form.text_area t('article.comment.commentBody') %>
	</p>
	<p>
	<%= form.label :status %><br>
		<%= form.select :status, ['public', 'private', 'archived'], selected: 'public' %>
	</p>
	<p>
	  <%= form.submit t('article.comment.submit'), class: 'btn btn-success' %>
	</p>
  <% end %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Blog</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
  <div class="container">

    <nav class="navbar navbar-expand-lg navbar-light bg-light">
      <div class="container-fluid">
        <div class="collapse navbar-collapse" id="navbarNav">
          <ul class="navbar-nav">
            <li class="nav-item">
              <a class="nav-link active" aria-current="page" href="<%= articles_path%>"><%=t('bar.articles')%></a>
            </li>
            <li class="nav-item">
              <a class="nav-link" href="#"><%=t('bar.description')%></a>
            </li>
          </ul>
        </div>
        <form class="form-inline my-2 my-lg-0" action="/search">
          <input class="form-control" name="q" type="text" placeholder="Search" aria-label="Search">
          <%# <button class="btn btn-outline-success" type="submit">Search</button> %>
        </form>
        <%= link_to t('bar.newArticle'), new_article_path, class: 'btn btn-outline-primary pull-xs-right' %>
        <ul class="navbar-nav">
          <li class="nav-item">
            <%= link_to "Укр", {locale: :ua},  class: "nav-link"%>
          </li>
          <li class="nav-item">
            <%= link_to "En", {locale: :en}, class: "nav-link"%>
          </li> 
        </ul>
      </div>
    </nav>

  </div>


  <div class="container main">
     <%= yield %>  
  </div>
  </body>
</html>

app/views/tags/show.html.erb
<h1><%= @tag.name %></h1>

<% if @tag.articles.empty? %>
	<h2>No articles</h2>
<% else %>
	<%= render @tag.articles %>
<% end %>